﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.Ribbon;
using Infragistics.Windows.DockManager;
using System.Windows.Interop;

namespace BaseRibbon
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void buttonTool_Click(object sender, RoutedEventArgs e)
        {
            ButtonTool tool = (ButtonTool)sender;
            msgBlk.Text = msgBlk.Text + "\n" + tool.Caption + " clicked";
        }

        private void CommandBinding_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            ContentPane pane = sender as ContentPane;
            if (pane != null)
            {
                if (pane.Tag == null)
                    pane.Tag = 1;
                else
                    pane.Tag = (int)pane.Tag + 1;
                ((TextBox)pane.Content).Text = "I am active" + pane.Tag.ToString();
            }

            
        }

        

        protected override void OnSourceInitialized(EventArgs e)
        {
            base.OnSourceInitialized(e);
            var source = HwndSource.FromVisual(this) as HwndSource;
            source.AddHook(FilterMessage);
        }
        /// <summary>
        /// Windows message loop filter. 
        /// Watches for WM_MOUSEACTIVATE and returns MA_NOACTIVATE for the main window.
        /// This prevents the main window from getting focus due to a menu click.
        /// </summary>
        private IntPtr FilterMessage(IntPtr hwnd, int msg, IntPtr wParam, IntPtr lParam, ref bool handled)
        {
            const int WM_MOUSEACTIVATE = 0x0021;
            const int MA_NOACTIVATE = 3;

            switch (msg)
            {
                case WM_MOUSEACTIVATE:
                    handled = true;
                    // TELL WINDOWS NOT TO ACTIVATE MAIN WINDOW.
                    return new IntPtr(MA_NOACTIVATE);
            }
            return IntPtr.Zero;
        }

        private void XamRibbon_PreviewGotKeyboardFocus(object sender, KeyboardFocusChangedEventArgs e)
        {
            //prevent the XamRibbon from gaining keyboard focus
            e.Handled = true;
        }


    }
}
